/* Procedure para gerar contas a receber*/
create or replace PROCEDURE GERA_CONTA(
   P_IDENTRSAID   IN NOTAFISCAL.IDENTRSAIDOP%TYPE,
   P_CDEMPRESA    IN NOTAFISCAL.CDEMPRESA%TYPE,
   P_CDFILIAL     IN NOTAFISCAL.CDFILIAL%TYPE,
   P_FILIORIGEM   IN NOTAFISCAL.CDFILIAL%TYPE,
   P_NRLANCTONF   IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_NRLANBOL     IN BOLETRECEBER.NRLANBOLREC%TYPE,
   P_VALORDOC     IN NOTAFISCAL.VRNOTAFISC%TYPE,
   P_CDTIPOOPER   IN NOTAFISCAL.CDTIPOOPER%TYPE,
   P_CDSERIE      IN NOTAFISCAL.CDSERIE%TYPE,
   P_IDORIGDEST   IN NOTAFISCAL.IDORIGDESTNF%TYPE,
   P_CDCLIEFORN   IN NOTAFISCAL.CDCLIENTE%TYPE,
   P_DTEMISSAO    IN DATE,
   P_DTENTRSAID   IN DATE,
   P_STATUSNF     IN NOTAFISCAL.IDSTATUS%TYPE,
   P_CDVENDEDOR   IN NOTAFISCAL.CDVENDEDOR%TYPE,
   P_DTLANCNF     IN NOTAFISCAL.DTLANCAMENNF%TYPE,
   P_DTVENCCONTA  IN DATE,
   P_CDTIPORECE   IN TIPORECE.CDTIPORECE%TYPE,
   P_DESCCONTA    IN TIPOCTRECEBER.DSTPCTRECEB%TYPE,
   P_NRCHEQUEVEND IN MOVCAIXA.NRCHEQUEVEND%TYPE,
   P_CDBANCHEQVEN IN MOVCAIXA.CDBANCHEQVEN%TYPE,
   P_CDAGECHEQVEN IN MOVCAIXA.CDAGECHEQVEN%TYPE,
   P_CDCNTCHEQVEN IN MOVCAIXA.CDCNTCHEQVEN%TYPE,
   P_NRINSJURCHEQ IN MOVCAIXA.NRINSJURCHEQ%TYPE,
   P_IDSTATCONTA  IN CONTAPAGAR.IDSTATPAG%TYPE,
   P_CDTPAJUSTE   IN AJCTPAGAR.CDAJUCTPAG%TYPE,
   P_VRAJUSTE     IN AJCTPAGAR.VRAJUSTEPAG%TYPE,
   P_CDOPERADOR   IN BAIXARECEBIDA.CDOPERADOR%TYPE)
AS
  V_CDINSCMUNI    NOTAFISCAL.CDINSCMUNI%TYPE;
  V_CDINSCESTA    NOTAFISCAL.CDINSCESTA%TYPE;
  V_CDCLASSFINA   CLASSFINANC.CDCLASSFINA%TYPE;
  V_NRLANCCONT    VARCHAR2(20);
  V_CDTIPOCONTA   CONTARECEBER.CDTPCTRECEB%TYPE;
  V_DSTPCTRECEB   TIPOCTRECEBER.DSTPCTRECEB%TYPE;
  V_DESCCONTA     TIPOCTRECEBER.DSTPCTRECEB%TYPE;
  V_VRPEMULTA     CLIENTE.VRPEMORBCLI%TYPE;
  V_VRPEMORA      CLIENTE.VRPEMULBCLI%TYPE;
  V_NRDOCUMENTO   NOTAFISCAL.NRNOTAFISC%TYPE;

BEGIN
   BEGIN
      SELECT MAX(CDINSCMUNI), MAX(CDINSCESTA)
      INTO V_CDINSCMUNI, V_CDINSCESTA
      FROM FILIAL
      WHERE CDFILIAL = P_FILIORIGEM;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN V_CDINSCMUNI := ''; V_CDINSCESTA := '';
   END;

   BEGIN
      SELECT MAX(TR.CDTPCTRECEB), MAX(TC.DSTPCTRECEB)
      INTO V_CDTIPOCONTA, V_DESCCONTA
      FROM TIPORECE TR, TIPOCTRECEBER TC
      WHERE TR.CDTIPORECE = P_CDTIPORECE AND
            TR.CDTPCTRECEB = TC.CDTPCTRECEB;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN V_CDTIPOCONTA := '';
   END;
   
   IF P_DESCCONTA IS NOT NULL THEN
      V_DESCCONTA := P_DESCCONTA;
   END IF;

   BEGIN
      SELECT MAX(VRPEMULBCLI), MAX(VRPEMORBCLI)
      INTO V_VRPEMULTA, V_VRPEMORA
      FROM CLIENTE
      WHERE CDCLIENTE = P_CDCLIEFORN;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         BEGIN
            SELECT MAX(VRPEMULEMPR), MAX(VRPEMOREMPR)
            INTO V_VRPEMULTA, V_VRPEMORA
            FROM EMPRESA
            WHERE (CDEMPRESA = P_CDEMPRESA);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN V_VRPEMULTA := 0; V_VRPEMORA := 0;
         END;
   END;

   /* Busca o nmero do lanamento contbil*/
   NOVO_CODIGO('LANCCONTABIL' || P_CDEMPRESA || TO_CHAR(P_DTEMISSAO,'YYYYMM'), V_NRLANCCONT);
   V_NRLANCCONT := SUBSTR(V_NRLANCCONT, 9, 12);

   /* Busca o nmero do documento */
   NOVO_CODIGO('NRNOTAFISCREC', V_NRDOCUMENTO);
   V_NRDOCUMENTO := SUBSTR(V_NRDOCUMENTO, 14, 7);

   INCLUI_NOTA(P_IDENTRSAID, P_CDEMPRESA, V_CDINSCESTA, V_CDINSCMUNI, P_CDFILIAL, P_NRLANCTONF,
               P_FILIORIGEM, P_VALORDOC, P_CDTIPOOPER, P_IDORIGDEST, P_CDCLIEFORN, V_NRDOCUMENTO,
               P_CDSERIE, P_DTEMISSAO, P_DTENTRSAID, '', P_CDVENDEDOR, '',
               P_STATUSNF, P_DTLANCNF);

   BEGIN
      SELECT MAX(CDCLASSFINA)
      INTO V_CDCLASSFINA
      FROM TIPOCTRECEBER
      WHERE CDTPCTRECEB = V_CDTIPOCONTA;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN V_CDCLASSFINA := '';
   END;

   GERA_BOLETOS_REC(P_NRLANBOL, P_CDFILIAL, P_CDCLIEFORN,
                    P_CDEMPRESA, P_VALORDOC, P_DTVENCCONTA,
                    P_CDTIPORECE, P_NRCHEQUEVEND, P_CDBANCHEQVEN,
                    P_CDAGECHEQVEN, P_CDCNTCHEQVEN);

   ATUALIZA_FLUXO_DE_CAIXA(P_CDEMPRESA,
                           P_CDFILIAL,
                           P_DTVENCCONTA,
                           'E',
                           V_CDCLASSFINA,
                           P_VALORDOC,
                           0);

   INCLUI_CONTA(P_IDENTRSAID, P_CDEMPRESA, P_CDFILIAL, P_NRLANCTONF,
                '01', P_VALORDOC, P_DTVENCCONTA,
                V_DESCCONTA, V_CDTIPOCONTA,
                0, '00', P_IDSTATCONTA,
                V_CDCLASSFINA, P_NRLANBOL);

   IF (P_CDTPAJUSTE IS NOT NULL) AND (P_VRAJUSTE <> 0) THEN
      GERA_AJUSTE_BOL(P_CDEMPRESA, P_CDFILIAL, P_NRLANBOL,
                      P_CDTPAJUSTE, P_VRAJUSTE);
   END IF;

   GERA_RATEIO_CONTA(P_IDENTRSAID, P_CDFILIAL, P_NRLANCTONF, '01',
                     '00', P_VALORDOC, V_CDTIPOCONTA, P_CDFILIAL);

END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_CONTA','5.01.016'); END;
/

